URLDecoder (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.net, class: URLDecoder
Keywords: java.net.URLDecoder class

# Class URLDecoder

java.lang.Object
java.net.URLDecoder

public final class URLDecoder extends Object
Utility class for HTML form decoding. This class contains static methods for decoding a String from the `application/x-www-form-urlencoded` MIME format.

The conversion process is the reverse of that used by the URLEncoder class. It is assumed that all characters in the encoded string are one of the following: "`a`" through "`z`", "`A`" through "`Z`", "`0`" through "`9`", and "`-`", "`_`", "`.`", and "`*`". The character "`%`" is allowed but is interpreted as the start of a special escaped sequence.

The following rules are applied in the conversion:

- The alphanumeric characters "`a`" through "`z`", "`A`" through "`Z`" and "`0`" through "`9`" remain the same.
- The special characters "`.`", "`-`", "`*`", and "`_`" remain the same.
- The plus sign "`+`" is converted into a space character " " .
- A sequence of the form "`%xy`" will be treated as representing a byte where xy is the two-digit hexadecimal representation of the 8 bits. Then, all substrings that contain one or more of these byte sequences consecutively will be replaced by the character(s) whose encoding would result in those consecutive bytes. The encoding scheme used to decode these characters may be specified, or if unspecified, the default charset will be used.

There are two possible ways in which this decoder could deal with illegal strings. It could either leave illegal characters alone or it could throw an `IllegalArgumentException`. Which approach the decoder takes is left to the implementation.

Since:
  1.2
See Also:
  - `Charset.defaultCharset()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static String`
  `decode(String s)`
  Deprecated.
  The resulting string may vary depending on the default charset.
  `static String`
  `decode(String s, String enc)`
  Decodes an `application/x-www-form-urlencoded` string using a specific encoding scheme.
  `static String`
  `decode(String s, Charset charset)`
  Decodes an `application/x-www-form-urlencoded` string using a specific Charset.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### decode

    @Deprecated public static String decode(String s)
    Deprecated.
    The resulting string may vary depending on the default charset. Instead, use the decode(String,String) method to specify the encoding.
    Decodes a `x-www-form-urlencoded` string. The default charset is used to determine what characters are represented by any consecutive sequences of the form "`%xy`".
    Parameters:
      `s` - the `String` to decode
    Returns:
      the newly decoded `String`
    Throws:
      `IllegalArgumentException` - if the implementation encounters malformed escape sequences

  - ### decode

    public static String decode(String s, String enc) throws UnsupportedEncodingException
    Decodes an `application/x-www-form-urlencoded` string using a specific encoding scheme.

    This method behaves the same as decode(java.lang.String,java.nio.charset.Charset) except that it will look up the charset using the given encoding name.

    Parameters:
      `s` - the `String` to decode
      `enc` - The name of a supported character encoding.
    Returns:
      the newly decoded `String`
    Throws:
      `UnsupportedEncodingException` - If character encoding needs to be consulted, but named character encoding is not supported
      `IllegalArgumentException` - if the implementation encounters malformed escape sequences
    Since:
      1.4
    See Also:
      - `URLEncoder.encode(java.lang.String, java.lang.String)`

  - ### decode

    public static String decode(String s, Charset charset)
    Decodes an `application/x-www-form-urlencoded` string using a specific Charset. The supplied charset is used to determine what characters are represented by any consecutive escape sequences of the form "`%xy`". Erroneous bytes are replaced with the supplied `Charset`'s replacement value.

    Note: The World Wide Web Consortium Recommendation states that UTF-8 should be used. Not doing so may introduce incompatibilities.

    Parameters:
      `s` - the `String` to decode
      `charset` - the given charset
    Returns:
      the newly decoded `String`
    Throws:
      `NullPointerException` - if `s` or `charset` is `null`
      `IllegalArgumentException` - if the implementation encounters malformed escape sequences
    Since:
      10
    External Specifications
      - HTML 4.01 Specification
    See Also:
      - `URLEncoder.encode(java.lang.String, Charset)`